all:    wins marm doc

clean:  wins_clean marm_clean

clobber:  wins_clobber marm_clobber vc5_clobber

build:  wins_build marm_build

rebuild:	clean build

package:  wins_package marm_package

#-----------------------------------------------------------------------------
vc5:	$(PKG).dsp

$(PKG).dsp:   $(PKG).mmp
        makmake $(PKG) vc5

vc5_clobber:
	-del $(PKG).dsp

#-----------------------------------------------------------------------------
wins:  	$(PKG).wins wins_clean wins_build wins_package

$(PKG).wins:   $(PKG).mmp
        makmake $(PKG) wins

wins_build:
        $(MAKE) -f $(PKG).wins

wins_clean:
        $(MAKE) -f $(PKG).wins clean

wins_clobber:
        -$(MAKE) -f $(PKG).wins clean
	-del $(PKG).wins

wins_package: $(PKG).oxh
        -makesis $(PKG).wins.pkg
	del ..\\$(PKG).wins.sis
	move $(PKG).wins.sis ..\$(PKG).wins.sis

#-----------------------------------------------------------------------------
marm:	$(PKG).marm marm_clean marm_build marm_package

$(PKG).marm:   $(PKG).mmp
        makmake $(PKG) marm

marm_build:
        $(MAKE) -f $(PKG).marm

marm_clean:
        $(MAKE) -f $(PKG).marm clean

marm_clobber:
        $(MAKE) -f $(PKG).marm clean
	del $(PKG).marm

marm_package:   $(PKG).oxh
        -makesis $(PKG).pkg
	del ..\\$(PKG).sis
	move $(PKG).sis ..\$(PKG).sis

#-----------------------------------------------------------------------------
$(PKG).oxh: $(PKG).sxh
        ..\tools\psicvt.pl -opl $(PKG).sxh

#-----------------------------------------------------------------------------
doc:
        cd documentation
        makedb
        cd ..

#-----------------------------------------------------------------------------
zip:
	-del *.tmp *.plg
	cd documentation
	-del ..\..\Zips\$(PKG)-html.zip
	wzzip -a ..\..\Zips\$(PKG)-html.zip *.htm
	-del ..\..\Zips\$(PKG)-cvs.zip
	wzzip -a ..\..\Zips\$(PKG)-cvs.zip *.csv
	cd ..
	cd tests
	-del ..\..\Zips\$(PKG)-test.zip
	wzzip -a ..\..\Zips\$(PKG)-test.zip *.*
	cd ..
	cd ..
	-del Zips\$(PKG)-wins-sis.zip
	wzzip -a Zips\$(PKG)-wins-sis.zip $(PKG).wins.sis
	-del Zips\$(PKG)-sis.zip
	wzzip -a Zips\$(PKG)-sis.zip $(PKG).sis
	-del Zips\$(PKG).zip
	wzzip -apr Zips\$(PKG).zip $(PKG) Makefile.inc
	cd $(PKG)
