#include "OpxCDesCArray.h"
#include <badesca.h>

//------------------------------------------------ Append a descriptor element
//
//	DesCArrayAppend:(this&,des&)
//
void COpxCDesCArray::AppendL(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	ptrThis->AppendL(*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------- Delete descriptor elements by position
//
//	DesCArrayDelete:(this&,pos&,count&)
//
void COpxCDesCArray::Delete(OplAPI& aOplAPI)
	{
	TInt argCount = aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	ptrThis->Delete(argPos,argCount);
	aOplAPI.Push(0.0);
	}

//---------------------------------- Find a descriptor using sequential search
//
//	DesCArrayFind%:(this&,des&,BYREF pos&,type%)
//
void COpxCDesCArray::Find(OplAPI& aOplAPI)
	{
	TKeyCmpText argTextComparisonType = (TKeyCmpText)aOplAPI.PopInt16();
	TInt32* ptrPos = aOplAPI.PopPtrInt32();
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	TInt pos;
	TInt result = ptrThis->Find(*ptrDes,pos,argTextComparisonType);
	OplAPI::PutLong(ptrPos,pos);
	aOplAPI.Push((TInt16)result);
	}

//-------------------------------------- Find a descriptor using binary search
//
//	DesCArrayFindIsq%:(this&,des&,BYREF pos&,type%)
//
void COpxCDesCArray::FindIsq(OplAPI& aOplAPI)
	{
	TKeyCmpText argTextComparisonType = (TKeyCmpText)aOplAPI.PopInt16();
	TInt32* ptrPos = aOplAPI.PopPtrInt32();
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	TInt pos;
	TInt result = ptrThis->Find(*ptrDes,pos,argTextComparisonType);
	OplAPI::PutLong(ptrPos,pos);
	aOplAPI.Push((TInt16)result);
	}

//---------------------------------------------------------------------- Index
//
//	DesCArrayIndex&:(this&,index&)
//
void COpxCDesCArray::Index(OplAPI& aOplAPI)
	{
	TInt argIndex = aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	TPtrC* pDes = new (ELeave) TPtrC((*ptrThis)[argIndex]);
	aOplAPI.Push((TInt32)pDes);
	}

//------------------------------------ Insert a descriptor element by position
//
//	DesCArrayInsert:(this&,pos&,des&)
//
void COpxCDesCArray::InsertL(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	ptrThis->InsertL(argPos,*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------ Insert a descriptor element in sequence
//
//	DesCArrayInsertIsq&:(this&,des&,type%)
//
void COpxCDesCArray::InsertIsqL(OplAPI& aOplAPI)
	{
	TKeyCmpText argTextComparisonType = (TKeyCmpText)aOplAPI.PopInt16();
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->InsertIsqL(*ptrDes,argTextComparisonType));
	}

//------------------------------------ Insert a descriptor element in sequence
//
//	DesCArrayInsertIsqAllowDuplicates&:(this&,des&,type%)
//
void COpxCDesCArray::InsertIsqAllowDuplicatesL(OplAPI& aOplAPI)
	{
	TKeyCmpText argTextComparisonType = (TKeyCmpText)aOplAPI.PopInt16();
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->InsertIsqAllowDuplicatesL(*ptrDes,argTextComparisonType));
	}

//------------------------------------- Number of descriptor elements in array
//
//	DesCArrayMdcaCount&:(this&)
//
void COpxCDesCArray::MdcaCount(OplAPI& aOplAPI)
	{
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MdcaCount());
	}

//------------------------------------------------------------ Empty the array
//
//	DesCArrayReset:(this&)
//
void COpxCDesCArray::Reset(OplAPI& aOplAPI)
	{
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	ptrThis->Reset();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------- Sort the descriptor elements
//
//	DesCArraySort:(this&,type%)
//
void COpxCDesCArray::Sort(OplAPI& aOplAPI)
	{
	TKeyCmpText argTextComparisonType = (TKeyCmpText)aOplAPI.PopInt16();
	CDesCArray* ptrThis = (CDesCArray*)aOplAPI.PopInt32();

	ptrThis->Sort(argTextComparisonType);
	aOplAPI.Push(0.0);
	}

