#include "OpxTDes.h"

//--------------------------------------------------------------------- Append
//
//	DesAppend:(this&,des&)
//
void COpxTDes::Append(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Append(*ptrDes);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------- Append character
//
//	DesAppendChar:(this&,char%)
//
void COpxTDes::AppendChar(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Append(argChar);
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------- Append fill
//
//	DesAppendFill:(this&,char%,length&)
//
void COpxTDes::AppendFill(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();
	TChar argChar = aOplAPI.PopInt16();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendFill(argChar,argLength);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Append justify
//
//	DesAppendJustify:(this&,des&,width&,align%,fill%)
//
void COpxTDes::AppendJustify(OplAPI& aOplAPI)
	{
	TChar argFill = (TChar)aOplAPI.PopInt16();
	TAlign argAlign = STATIC_CAST(TAlign,aOplAPI.PopInt16());
	TInt argWidth = aOplAPI.PopInt32();
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendJustify(*ptrDes,argWidth,argAlign,argFill);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------ Append justify string
//
//	DesAppendJustifyStr:(this&,str$,width&,align%,fill%)
//
void COpxTDes::AppendJustifyStr(OplAPI& aOplAPI)
	{
	TChar argFill = (TChar)aOplAPI.PopInt16();
	TAlign argAlign = STATIC_CAST(TAlign,aOplAPI.PopInt16());
	TInt argWidth = aOplAPI.PopInt32();
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendJustify(argStr,argWidth,argAlign,argFill);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------- Append num
//
//	DesAppendNum:(this&,num&)
//
void COpxTDes::AppendNum(OplAPI& aOplAPI)
	{
	TInt argNum = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendNum(argNum);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------ Append num with radix
//
//	DesAppendNumRadix:(this&,num&,radix&)
//
void COpxTDes::AppendNumRadix(OplAPI& aOplAPI)
	{
	TRadix argRadix = STATIC_CAST(TRadix,aOplAPI.PopInt32());
	TUint argNum = (TUint)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendNum(argNum,argRadix);
	aOplAPI.Push(0.0);
	}

//---------------------------------------- Append num with radix and uppercase
//
//	DesAppendNumRadixUC:(this&,num&,radix&)
//
void COpxTDes::AppendNumRadixUC(OplAPI& aOplAPI)
	{
	TRadix argRadix = STATIC_CAST(TRadix,aOplAPI.PopInt32());
	TUint argNum = (TUint)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->AppendNumUC(argNum,argRadix);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------- Append num floating point
//
//	DesAppendNumFloat%:(this&,float,format&)
//
void COpxTDes::AppendNumFloat(OplAPI& aOplAPI)
	{
	TRealFormat* ptrFormat = (TRealFormat*)aOplAPI.PopInt32();
	TReal argFloat = aOplAPI.PopReal64();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	TInt err = ptrThis->AppendNum(argFloat,*ptrFormat);
	aOplAPI.Push((TInt16)OplAPI::MapError(err));
	}

//-------------------------------------------------------------- Append string
//
//	DesAppendStr:(this&,str$)
//
void COpxTDes::AppendStr(OplAPI& aOplAPI)
	{
	TPtrC argString = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Append(argString);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------- Capitalize
//
//	DesCapitalize:(this&)
//
void COpxTDes::Capitalize(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Capitalize();
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------------- Collate
//
//	DesCollate:(this&)
//
void COpxTDes::Collate(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Collate();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Copy
//
//	DesCopy:(this&,des&)
//
void COpxTDes::Copy(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Copy(*ptrDes);
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------- Copy colate
//
//	DesCopyC:(this&,str$)
//
void COpxTDes::CopyC(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyC(*ptrDes);
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------- Copy folding
//
//	DesCopyF:(this&,str$)
//
void COpxTDes::CopyF(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyF(*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Copy lowercase
//
//	DesCopyLC:(this&,str$)
//
void COpxTDes::CopyLC(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyLC(*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Copy uppercase
//
//	TDesCopyUC:(this&,str$)
//
void COpxTDes::CopyUC(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyUC(*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------ Copy capilatize
//
//	DesCopyCP:(this&,str$)
//
void COpxTDes::CopyCP(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyCP(*ptrDes);
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------- Copy string
//
//	DesCopyStr:(this&,str$)
//
void COpxTDes::CopyStr(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Copy(argStr);
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------- Copy string colate
//
//	DesCopyStrC:(this&,str$)
//
void COpxTDes::CopyStrC(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyC(argStr);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------- Copy string folding
//
//	DesCopyStrF:(this&,str$)
//
void COpxTDes::CopyStrF(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyF(argStr);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------ Copy string lowercase
//
//	DesCopyStrLC:(this&,str$)
//
void COpxTDes::CopyStrLC(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyLC(argStr);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------ Copy string uppercase
//
//	DesCopyStrUC:(this&,str$)
//
void COpxTDes::CopyStrUC(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyUC(argStr);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------- Copy string capilatize
//
//	DesCopyStrCP:(this&,str$)
//
void COpxTDes::CopyStrCP(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->CopyCP(argStr);
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------------- Delete
//
//	DesDelete:(this&,pos&,length&)
//
void COpxTDes::Delete(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Delete(argPos,argLength);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Fill
//
//	DesFill:(this&,char%)
//
void COpxTDes::Fill(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Fill(argChar);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------- Fill with length
//
//	DesFillLen:(this&,char%,length&)
//
void COpxTDes::FillLen(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();
	TChar argChar = aOplAPI.PopInt16();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Fill(argChar,argLength);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Fill with zero
//
//	DesFillZ:(this&)
//
void COpxTDes::FillZ(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->FillZ();
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------- Fill with zero for length
//
//	DesFillZLen:(this&,length&)
//
void COpxTDes::FillZLen(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->FillZ(argLength);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Fold
//
//	DesFold:(this&)
//
void COpxTDes::Fold(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Fold();
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------------- Insert
//
//	DesInsert:(this&,pos&,str$)
//
void COpxTDes::Insert(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TInt argPos = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Insert(argPos,argStr);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------- Insert string
//
//	DesInsertStr:(this&,pos&,str$)
//
void COpxTDes::InsertStr(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TInt argPos = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Insert(argPos,argStr);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------------- Justify
//
//	DesJustify:(this&,des&,width&,align%,fill%)
//
void COpxTDes::Justify(OplAPI& aOplAPI)
	{
	TChar argFill = (TChar)aOplAPI.PopInt16();
	TAlign argAlign = STATIC_CAST(TAlign,aOplAPI.PopInt16());
	TInt argWidth = aOplAPI.PopInt32();
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Justify(*ptrDes,argWidth,argAlign,argFill);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Justify string
//
//	DesJustifyStr:(this&,str$,width&,align%,fill%)
//
void COpxTDes::JustifyStr(OplAPI& aOplAPI)
	{
	TChar argFill = (TChar)aOplAPI.PopInt16();
	TAlign argAlign = STATIC_CAST(TAlign,aOplAPI.PopInt16());
	TInt argWidth = aOplAPI.PopInt32();
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Justify(argStr,argWidth,argAlign,argFill);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------ Lowercase
//
//	DesLowerCase:(this&)
//
void COpxTDes::LowerCase(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->LowerCase();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Maximum length
//
//	DesMaxLength&:(this&)
//
void COpxTDes::MaxLength(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MaxLength());
	}

//------------------------------------------------------------------------ Num
//
//	DesNum:(this&,num&)
//
void COpxTDes::Num(OplAPI& aOplAPI)
	{
	TInt argNum = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Num(argNum);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Num with radix
//
//	DesNumRadix:(this&,num&,radix&)
//
void COpxTDes::NumRadix(OplAPI& aOplAPI)
	{
	TRadix argRadix = STATIC_CAST(TRadix,aOplAPI.PopInt32());
	TUint argNum = (TUint)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Num(argNum,argRadix);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------- Num with radix and uppercase
//
//	DesNumRadixUC:(this&,num&,radix&)
//
void COpxTDes::NumRadixUC(OplAPI& aOplAPI)
	{
	TRadix argRadix = STATIC_CAST(TRadix,aOplAPI.PopInt32());
	TUint argNum = (TUint)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->NumUC(argNum,argRadix);
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------- Num floating point
//
//	DesNumFloat%:(this&,float,format&)
//
void COpxTDes::NumFloat(OplAPI& aOplAPI)
	{
	TRealFormat* ptrFormat = (TRealFormat*)aOplAPI.PopInt32();
	TReal argFloat = aOplAPI.PopReal64();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	TInt err = ptrThis->Num(argFloat,*ptrFormat);
	aOplAPI.Push((TInt16)OplAPI::MapError(err));
	}

//--------------------------------------------------------------------- Repeat
//
//	DesRepeat:(this&,des&)
//
void COpxTDes::Repeat(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Repeat(*ptrDes);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------- Repeat string
//
//	DesRepeatStr:(this&,str$)
//
void COpxTDes::RepeatStr(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Repeat(argStr);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------------- Replace
//
//	DesReplace:(this&,pos&,length&,des&)
//
void COpxTDes::Replace(OplAPI& aOplAPI)
	{
	TDes* ptrDes = (TDes*)aOplAPI.PopInt32();
	TInt argLength = aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Replace(argPos,argLength,*ptrDes);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Replace string
//
//	DesReplaceStr:(this&,pos&,length&,str$)
//
void COpxTDes::ReplaceStr(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TInt argLength = aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Replace(argPos,argLength,argStr);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------- Set length
//
//	DesSetLength&:(this&,length&)
//
void COpxTDes::SetLength(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->SetLength(argLength);
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------- Set maximum
//
//	DesSetMax:(this&)
//
void COpxTDes::SetMax(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->SetMax();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Swap
//
//	DesSwap:(this&,des&)
//
void COpxTDes::Swap(OplAPI& aOplAPI)
	{
	TDes* ptrTDes = (TDes*)aOplAPI.PopInt32();
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Swap(*ptrTDes);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Trim
//
//	DesTrim:(this&)
//
void COpxTDes::Trim(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Trim();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------- Trim all
//
//	DesTrimAll:(this&)
//
void COpxTDes::TrimAll(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->TrimAll();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------ Trim left
//
//	DesTrimLeft:(this&)
//
void COpxTDes::TrimLeft(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->TrimLeft();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------- Trim right
//
//	DesTrimRight:(this&)
//
void COpxTDes::TrimRight(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->TrimRight();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------ Uppercase
//
//	DesUpperCase:(this&)
//
void COpxTDes::UpperCase(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->UpperCase();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Zero
//
//	DesZero:(this&)
//
void COpxTDes::Zero(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->Zero();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------- Zero terminate
//
//	DesZeroTerminate:(this&)
//
void COpxTDes::ZeroTerminate(OplAPI& aOplAPI)
	{
	TDes* ptrThis = (TDes*)aOplAPI.PopInt32();

	ptrThis->ZeroTerminate();
	aOplAPI.Push(0.0);
	}
