#include "OpxTLex.h"

//---------------------------------------------------- New lexical analyser
//
//	NewLex&:
//
void COpxTLex::NewLexL(OplAPI& aOplAPI)
	{

	aOplAPI.Push((TInt32)new (ELeave) TLex);
	}

//
//	NewLex2&:(str$)
//
void COpxTLex::NewLex2L(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();

	aOplAPI.Push((TInt32)new (ELeave) TLex(argStr));
	}

//
//	NewLex3&:(des&)
//
void COpxTLex::NewLex3L(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)new (ELeave) TLex(*ptrDes));
	}

//
//	NewLex4&:(lex&)
//
void COpxTLex::NewLex4L(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)new (ELeave) TLex(*ptrThis));
	}

//------------------------------------------------- Delete lexical analyser
//
//	DeleteLex:(BYREF this&)
//
void COpxTLex::DeleteLex(OplAPI& aOplAPI)
	{
	TAny *ptrLong = aOplAPI.PopPtrInt32();

	TLex* ptrThis = (TLex*)OplAPI::GetLong(ptrLong);
	delete ptrThis;
	OplAPI::PutLong(ptrLong,0);
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------------- Assign
//
//	LexAssign:(this&,lex&)
//
void COpxTLex::Assign(OplAPI& aOplAPI)
	{
	const TLex* ptrLex = (TLex*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->Assign(*ptrLex);
	aOplAPI.Push(0.0);
	}

//
//	LexAssignDes:(this&,des&)
//
void COpxTLex::AssignDes(OplAPI& aOplAPI)
	{
	const TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->Assign(*ptrDes);
	aOplAPI.Push(0.0);
	}

//
//	LexAssignStr:(this&,str$)
//
void COpxTLex::AssignStr(OplAPI& aOplAPI)
	{
	TPtrC argStr = aOplAPI.PopString8();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->Assign(argStr);
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------- End of string
//
//	LexEos%:(this&)
//
void COpxTLex::Eos(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TBool result = ptrThis->Eos();
	aOplAPI.Push((TInt16)(result ? -1 : 0));
	}

//------------------------------------------------------------------------ Get
//
//	LexGet%:(this&)
//
void COpxTLex::Get(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->Get());
	}

//------------------------------------------------------------------------ Inc
//
//	LexInc:(this&,number&)
//
void COpxTLex::Inc(OplAPI& aOplAPI)
	{
	TInt argNumber = aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->Inc(argNumber);
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------------- Mark
//
//	LexMark:(this&,mark&)
//
void COpxTLex::Mark(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrMark ? ptrThis->Mark(*ptrMark) :
		  ptrThis->Mark();;
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------- Marked offset
//
//	LexMarkedOffset&:(this&,mark&)
//
void COpxTLex::MarkedOffset(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TInt32 offset = ptrMark ? ptrThis->MarkedOffset(*ptrMark) :
				  ptrThis->MarkedOffset();
	aOplAPI.Push(offset);
	}

//--------------------------------------------------------------- Marked token
//
//	LexMarkedToken&:(this&)
//
void COpxTLex::MarkedTokenL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC *ptrToken = new (ELeave) TPtrC(ptrThis->MarkedToken());
	aOplAPI.Push((TInt32)ptrToken);
	}

//
//	LexMarkedTokenStr$:(this&)
//
void COpxTLex::MarkedTokenStrL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC token = ptrThis->MarkedToken();
	aOplAPI.PushL(token);
	}

//----------------------------------------------------------------- Next token
//
//	LexNextToken&:(this&)
//
void COpxTLex::NextTokenL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC* ptrToken = new (ELeave) TPtrC(ptrThis->NextToken());
	aOplAPI.Push((TInt32)ptrToken);
	}

//
//	LexNextTokenStr$:(this&)
//
void COpxTLex::NextTokenStrL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC token = ptrThis->NextToken();
	aOplAPI.PushL(token);
	}

//--------------------------------------------------------------------- Offset
//
//	LexOffset&:(this&)
//
void COpxTLex::Offset(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Offset());
	}

//----------------------------------------------------------------------- Peek
//
//	LexPeek%:(this&)
//
void COpxTLex::Peek(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Peek());
	}

//------------------------------------------------------------------ Remainder
//
//	LexRemainder&:(this&)
//
void COpxTLex::RemainderL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC *ptrRemainder = new (ELeave) TPtrC(ptrThis->Remainder());
	aOplAPI.Push((TInt32)ptrRemainder);
	}

//
//	LexRemainderStr$:(this&)
//
void COpxTLex::RemainderStrL(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	aOplAPI.PushL(ptrThis->Remainder());
	}

//-------------------------------------------------------- Remainder from mark
//
//	LexRemainderFromMark&:(this&,mark&)
//
void COpxTLex::RemainderFromMarkL(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC *ptrRemainder = new (ELeave) TPtrC(ptrMark ?
				    ptrThis->RemainderFromMark(*ptrMark) :
				    ptrThis->RemainderFromMark());

	aOplAPI.Push((TInt32)ptrRemainder);
	}

//
//	LexRemainderFromMarkStr$:(this&,mark&)
//
void COpxTLex::RemainderFromMarkStrL(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TPtrC remainder = ptrMark ? ptrThis->RemainderFromMark(*ptrMark) :
				    ptrThis->RemainderFromMark();

	aOplAPI.PushL(remainder);
	}

//-------------------------------------------------------------- Skip and mark
//
//	LexSkipAndMark:(this&,number&,mark&)
//
void COpxTLex::SkipAndMark(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TInt argNumber = aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrMark ? ptrThis->SkipAndMark(argNumber,*ptrMark) :
		  ptrThis->SkipAndMark(argNumber);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------ Skip characters
//
//	LexSkipCharacters:(this&)
//
void COpxTLex::SkipCharacters(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->SkipCharacters();
	aOplAPI.Push(0.0);
	}

//----------------------------------------------------------------- Skip space
//
//	LexSkipSpace:(this&)
//
void COpxTLex::SkipSpace(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->SkipSpace();
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------- Skip space and mark
//
//	LexSkipSpaceAndMark:(this&,mark&)
//
void COpxTLex::SkipSpaceAndMark(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrMark ? ptrThis->SkipSpaceAndMark(*ptrMark) :
		  ptrThis->SkipSpaceAndMark();
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------- Token length
//
//	LexTokenLength&:(this&,mark&)
//
void COpxTLex::TokenLength(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TInt32 len = ptrMark ? ptrThis->TokenLength(*ptrMark) :
			       ptrThis->TokenLength();
	aOplAPI.Push(len);
	}

//---------------------------------------------------------------------- Unget
//
//	LexUnGet:(this&)
//
void COpxTLex::UnGet(OplAPI& aOplAPI)
	{
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrThis->UnGet();
	aOplAPI.Push(0.0);
	}

//-------------------------------------------------------------- Unget to mark
//
//	LexUnGetToMark:(this&,mark&)
//
void COpxTLex::UnGetToMark(OplAPI& aOplAPI)
	{
	TLexMark* ptrMark = (TLexMark*)aOplAPI.PopInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	ptrMark ? ptrThis->UnGetToMark(*ptrMark) :
		  ptrThis->UnGetToMark();
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------------ Val
//
//	LexVal%:(this&,BYREF value&)
//
void COpxTLex::Val(OplAPI& aOplAPI)
	{
	TInt32* ptrAny = aOplAPI.PopPtrInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TInt32 value;
	TInt result = ptrThis->Val(value);
	OplAPI::PutLong(ptrAny,value);
	aOplAPI.Push((TInt16)OplAPI::MapError(result));
	}

//------------------------------------------------------------------ Val float
//
//	LexValFloat%:(this&,BYREF value,point%)
//
void COpxTLex::ValFloat(OplAPI& aOplAPI)
	{
	TChar argPoint = aOplAPI.PopInt16();
	TReal64* ptrAny = aOplAPI.PopPtrReal64();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TReal64 value;
	TInt result = ptrThis->Val(value,argPoint);
	OplAPI::PutFloat(ptrAny,value);
	aOplAPI.Push((TInt16)OplAPI::MapError(result));
	}

//------------------------------------------------------------------ Val radix
//
//	LexValRadix%:(this&,BYREF value&,radix&)
//
void COpxTLex::ValRadix(OplAPI& aOplAPI)
	{
	TInt32 argRadix = aOplAPI.PopInt32();
	TInt32* ptrAny = aOplAPI.PopPtrInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TInt32 value;
	TInt result = ptrThis->Val(value,argRadix);
	OplAPI::PutLong(ptrAny,value);
	aOplAPI.Push((TInt16)OplAPI::MapError(result));
	}

//------------------------------------------------------------ Val radix limit
//
//	LexValRadixLimit%:(this&,BYREF value&,radix&,limit&)
//
void COpxTLex::ValRadixLimit(OplAPI& aOplAPI)
	{
	TInt32 argLimit = aOplAPI.PopInt32();
	TRadix argRadix = STATIC_CAST(TRadix,aOplAPI.PopInt32());
	TInt32* ptrAny = aOplAPI.PopPtrInt32();
	TLex* ptrThis = (TLex*)aOplAPI.PopInt32();

	TUint32 value;
	TInt result = ptrThis->Val(value,argRadix,argLimit);
	OplAPI::PutLong(ptrAny,(TInt32)value);
	aOplAPI.Push((TInt16)OplAPI::MapError(result));
	}
