#include "OpxTPtr.h"

//------------------------------------------ New modifiable pointer descriptor
//
//	NewDes&:(buffer&,length&,maxLength&)
//
void COpxTPtr::NewTPtrL(OplAPI& aOplAPI)
	{
	TInt argMaxLength = aOplAPI.PopInt32();
	TInt argLength = aOplAPI.PopInt32();
	TInt argBuffer = aOplAPI.PopInt32();

	TUint8* buffer = aOplAPI.OffsetToAddrL(argBuffer,argMaxLength);
	aOplAPI.Push((TInt32)new (ELeave) TPtr(buffer,argLength,argMaxLength));
	}

//--------------------------------------- Delete modifiable pointer descriptor
//
//	DeleteDes:(BYREF this&)
//
void COpxTPtr::DeleteTPtr(OplAPI& aOplAPI)
	{
	TAny *ptrLong = aOplAPI.PopPtrInt32();

	TPtr* ptrThis = (TPtr*)OplAPI::GetLong(ptrLong);
	delete ptrThis;
	OplAPI::PutLong(ptrLong,0);
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------------ Set
//
//	DesSet:(this&,buffer&,length&,maxLength&)
//
void COpxTPtr::SetL(OplAPI& aOplAPI)
	{
	TInt argMaxLength = aOplAPI.PopInt32();
	TInt argLength = aOplAPI.PopInt32();
	TInt argBuffer = aOplAPI.PopInt32();
	TPtr* ptrThis = (TPtr*)aOplAPI.PopInt32();

	TUint8* buffer = aOplAPI.OffsetToAddrL(argBuffer, argMaxLength);
	ptrThis->Set(buffer,argLength,argMaxLength);
	aOplAPI.Push(0.0);
	}

//------------------------------------------- New allocated pointer descriptor
//
//	NewDesAlloc&:(length&)
//
void COpxTPtr::NewAllocL(OplAPI& aOplAPI)
	{
	TInt argLength = aOplAPI.PopInt32();

	TUint8* buffer = (TUint8*)User::AllocL(argLength);
	aOplAPI.Push((TInt32)new (ELeave) TPtr(buffer,0,argLength));
	}

//---------------------------------------- Delete allocated pointer descriptor
//
//	DeleteDesAlloc:(BYREF this&)
//
void COpxTPtr::DeleteAlloc(OplAPI& aOplAPI)
	{
	TAny *ptrLong = aOplAPI.PopPtrInt32();

	TPtr* ptrThis = (TPtr*)OplAPI::GetLong(ptrLong);
	TAny* ptr = (TAny*)ptrThis->Ptr();
	User::Free(ptr);
	delete ptrThis;
	OplAPI::PutLong(ptrLong,0);
	aOplAPI.Push(0.0);
	}
