#ifndef _OPXTLS_H
#define	_OPXTLS_H

#ifndef __OPLAPI_H__
#include <oplapi.h>
#endif

const TInt KOpxVersion = 0x100;

class COpxTls : public COpxBase
	{
public:
	// required OPX methods
	static COpxTls* NewLC(OplAPI& aOplAPI);
	virtual void RunL(TInt aProcNum);
	virtual TBool CheckVersion(TInt aVersion);
private:
	// the OPX extension method numbers
	enum TExtensions
		{
		ESocketOPXVersion = 1,

		ETDesCAt,
		ETDesCCompare,
		ETDesCCompareC,
		ETDesCCompareF,
		ETDesCCompareStr,
		ETDesCCompareStrC,
		ETDesCCompareStrF,
		ETDesCEQ,
		ETDesCEQStr,
		ETDesCFind,
		ETDesCFindC,
		ETDesCFindF,
		ETDesCFindStr,
		ETDesCFindStrC,
		ETDesCFindStrF,
		ETDesCGE,
		ETDesCGEStr,
		ETDesCGT,
		ETDesCGTStr,
		ETDesCLE,
		ETDesCLeft,
		ETDesCLength,
		ETDesCLEStr,
		ETDesCLocate,
		ETDesCLocateF,
		ETDesCLocateReverse,
		ETDesCLocateReverseF,
		ETDesCLT,
		ETDesCLTStr,
		ETDesCMatch,
		ETDesCMatchC,
		ETDesCMatchF,
		ETDesCMatchStr,
		ETDesCMatchStrC,
		ETDesCMatchStrF,
		ETDesCMid,
		ETDesCNE,
		ETDesCNEStr,
		ETDesCRight,
		ETDesCStr,

		ETDesAppend,
		ETDesAppendChar,
		ETDesAppendFill,
		ETDesAppendJustify,
		ETDesAppendJustifyStr,
		ETDesAppendNum,
		ETDesAppendNumFloat,
		ETDesAppendNumRadix,
		ETDesAppendNumRadixUC,
		ETDesAppendStr,
		ETDesCapitalize,
		ETDesCollate,
		ETDesCopy,
		ETDesCopyC,
		ETDesCopyCP,
		ETDesCopyF,
		ETDesCopyLC,
		ETDesCopyStr,
		ETDesCopyStrC,
		ETDesCopyStrCP,
		ETDesCopyStrF,
		ETDesCopyStrLC,
		ETDesCopyStrUC,
		ETDesCopyUC,
		ETDesDelete,
		ETDesFill,
		ETDesFillLen,
		ETDesFillZ,
		ETDesFillZLen,
		ETDesFold,
		ETDesInsert,
		ETDesInsertStr,
		ETDesJustify,
		ETDesJustifyStr,
		ETDesLowerCase,
		ETDesMaxLength,
		ETDesNum,
		ETDesNumFloat,
		ETDesNumRadix,
		ETDesNumRadixUC,
		ETDesRepeat,
		ETDesRepeatStr,
		ETDesReplace,
		ETDesReplaceStr,
		ETDesSetLength,
		ETDesSetMax,
		ETDesSwap,
		ETDesTrim,
		ETDesTrimAll,
		ETDesTrimLeft,
		ETDesTrimRight,
		ETDesUpperCase,
		ETDesZero,
		ETDesZeroTerminate,

		ENewTPtr,
		EDeleteTPtr,
		ETPtrSet,

		ENewAlloc,
		EDeleteAlloc,

		ENewTRealFormat,
		EDeleteTRealFormat,
		ETRealFormatPlaces,
		ETRealFormatPoint,
		ETRealFormatSetPlaces,
		ETRealFormatSetPoint,
		ETRealFormatSetTriad,
		ETRealFormatSetTriLen,
		ETRealFormatSetType,
		ETRealFormatSetWidth,
		ETRealFormatTriad,
		ETRealFormatTriLen,
		ETRealFormatType,
		ETRealFormatWidth,

		ENewLex,
		ENewLex2,
		ENewLex3,
		ENewLex4,
		EDeleteLex,
		ELexAssign,
		ELexAssignDes,
		ELexAssignStr,
		ELexEos,
		ELexGet,
		ELexInc,
		ELexMark,
		ELexMarkedOffset,
		ELexMarkedToken,
		ELexMarkedTokenStr,
		ELexNextToken,
		ELexNextTokenStr,
		ELexOffset,
		ELexPeek,
		ELexRemainder,
		ELexRemainderStr,
		ELexRemainderFromMark,
		ELexRemainderFromMarkStr,
		ELexSkipAndMark,
		ELexSkipCharacters,
		ELexSkipSpace,
		ELexSkipSpaceAndMark,
		ELexTokenLength,
		ELexUnGet,
		ELexUnGetToMark,
		ELexVal,
		ELexValFloat,
		ELexValRadix,
		ELexValRadixLimit,

		ENewLexMark,
		EDeleteLexMark
		};

	void ConstructL();
	COpxTls(OplAPI& aOplAPI);
	~COpxTls();

	void SocketOPXVersion(void);
	};

#endif // _OPXTLS_H
